SystemOrganization addCategory: #ConfigurationOfAmbientTalkST!

Object subclass: #ConfigurationOfAmbientTalkST
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfAmbientTalkST'!

!ConfigurationOfAmbientTalkST class methodsFor: 'development support' stamp: 'StefanMarr 1/2/2012 15:54'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfAmbientTalkST class methodsFor: 'private' stamp: 'StefanMarr 1/2/2012 15:54'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfAmbientTalkST class methodsFor: 'private' stamp: 'StefanMarr 1/2/2012 15:54'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfAmbientTalkST class methodsFor: 'private' stamp: 'StefanMarr 1/2/2012 15:54'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfAmbientTalkST class methodsFor: 'metacello tool support' stamp: 'StefanMarr 1/2/2012 15:54'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfAmbientTalkST class methodsFor: 'loading' stamp: 'StefanMarr 1/2/2012 15:54'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfAmbientTalkST class methodsFor: 'loading' stamp: 'StefanMarr 1/2/2012 15:54'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfAmbientTalkST class methodsFor: 'loading' stamp: 'StefanMarr 1/2/2012 15:54'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfAmbientTalkST class methodsFor: 'loading' stamp: 'StefanMarr 1/13/2013 15:12'!
loadPhD2013
	"This configuration reflects the project status used for benchmarks in my PhD dissertation"

	"self loadPhD2013"

	<apiDocumentation>
	^(self project version: #'phd2013') load! !

!ConfigurationOfAmbientTalkST class methodsFor: 'loading' stamp: 'StefanMarr 1/15/2012 22:52'!
loadTOOLS2012
	"This configuration represents the state of the project used for the initial paper submission
	 for TOOLS 2012"

	"self loadTOOLS2012"

	<apiDocumentation>
	^(self project version: #'tools2012') load! !

!ConfigurationOfAmbientTalkST class methodsFor: 'accessing' stamp: 'StefanMarr 1/2/2012 15:54'!
project

	^self new project! !

!ConfigurationOfAmbientTalkST class methodsFor: 'development support' stamp: 'StefanMarr 1/2/2012 15:54'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfAmbientTalkST methodsFor: 'baselines' stamp: 'StefanMarr 1/2/2012 16:32'!
baseline01: spec
	<version: '0.1-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://ss3.gemstone.com/ss/Omni'.
		
		"SMark Benchmarking"
		spec project: 'Benchmarking' with: [
				spec
					className: 'ConfigurationOfBenchmarking';
					versionString: #'bleedingEdge';
					repository: 'http://www.squeaksource.com/SMark' ].
		
		spec 
			package: 'AmbientTalkST-Core';
			package: 'AmbientTalkST-Benchmarks' with: [
				spec requires: #('AmbientTalkST-Core' 'Benchmarking'). ].
		
		spec 
			group: 'default'    with: #('Complete' );
			group: 'Core'       with: #('AmbientTalkST-Core' );
			group: 'Benchmarks' with: #('AmbientTalkST-Benchmarks' );
			group: 'Complete'   with: #('Core' 'Benchmarks' ). ].
! !

!ConfigurationOfAmbientTalkST methodsFor: 'baselines' stamp: 'StefanMarr 1/13/2013 19:35'!
baseline03: spec
	<version: '0.3-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://ss3.gemstone.com/ss/Omni'.
		
		"SMark Benchmarking"
		spec project: 'Benchmarking' with: [
				spec
					className: 'ConfigurationOfBenchmarking';
					versionString: '0.2';
					repository: 'http://www.squeaksource.com/SMark' ].
		
		spec 
			package: 'AmbientTalkST-Core';
			package: 'AmbientTalkST-Benchmarks' with: [
				spec requires: #('AmbientTalkST-Core' 'Benchmarking' 'CLBG-Compatibility'). ];
			package: 'CLBG-Compatibility' with: [
				spec requires: #('AmbientTalkST-Core')].
		
		spec 
			group: 'default'    with: #('Complete' );
			group: 'Core'       with: #('AmbientTalkST-Core' );
			group: 'Benchmarks' with: #('AmbientTalkST-Benchmarks' );
			group: 'Complete'   with: #('Core' 'Benchmarks' ). ].
! !

!ConfigurationOfAmbientTalkST methodsFor: 'baselines' stamp: 'StefanMarr 1/23/2013 12:45'!
baseline04: spec
	<version: '0.4-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://ss3.gemstone.com/ss/Omni'.
		
		"SMark Benchmarking"
		spec project: 'Benchmarking' with: [
				spec
					className: 'ConfigurationOfBenchmarking';
					versionString: #'bleedingEdge';
					repository: 'http://www.squeaksource.com/SMark' ].
		
		spec 
			package: 'AmbientTalkST-Core';
			package: 'CLBG-Compatibility' with: [
				spec requires: #('AmbientTalkST-Core')];
			package: 'AmbientTalkST-Tests' with: [
				spec requires: #('AmbientTalkST-Core')];
			package: 'AmbientTalkST-Benchmarks' with: [
				spec requires: #('AmbientTalkST-Core' 'Benchmarking' 'CLBG-Compatibility' 'AmbientTalkST-Tests'). ].
			
		
		spec 
			group: 'default'    with: #(Complete);
			group: 'Core'       with: #('AmbientTalkST-Core');
			group: 'Tests'      with: #('AmbientTalkST-Tests');
			group: 'Benchmarks' with: #('AmbientTalkST-Benchmarks');
			group: 'Complete'   with: #(Core Tests Benchmarks)
	]! !

!ConfigurationOfAmbientTalkST methodsFor: 'symbolic versions' stamp: 'StefanMarr 1/13/2013 15:19'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '0.4-baseline'.! !

!ConfigurationOfAmbientTalkST methodsFor: 'symbolic versions' stamp: 'StefanMarr 1/13/2013 15:10'!
phd2013: spec
	<symbolicVersion: #'phd2013'>

	spec for: #'common' version: '0.3-phd2013'.
! !

!ConfigurationOfAmbientTalkST methodsFor: 'accessing' stamp: 'StefanMarr 1/2/2012 15:54'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfAmbientTalkST methodsFor: 'symbolic versions' stamp: 'StefanMarr 1/15/2012 22:55'!
tools2012: spec
	<symbolicVersion: #'tools2012'>

	spec for: #'common' version: '0.2-tools2012'.
! !

!ConfigurationOfAmbientTalkST methodsFor: 'versions' stamp: 'StefanMarr 1/2/2012 16:02'!
version01: spec
	<version: '0.1' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: ''.
		spec author: 'StefanMarr'.
		spec timestamp: '1/02/2012 16:02'.
	].! !

!ConfigurationOfAmbientTalkST methodsFor: 'versions' stamp: 'StefanMarr 1/15/2012 22:53'!
version02: spec
	<version: '0.2-tools2012' imports: #('0.1-baseline') >

	spec for: #'common' do: [
		spec blessing: #'tools2012'.
		spec description: 'Configuration reflecting the project status used for the initial TOOLS2012 submission'.
		spec author: 'StefanMarr'.
		spec timestamp: '1/15/2012 22:50'.
	
		spec
			package: 'AmbientTalkST-Core' with: 'AmbientTalkST-Core-StefanMarr.7';
			package: 'AmbientTalkST-Benchmarks' with: 'AmbientTalkST-Benchmarks-StefanMarr.16'
	].! !

!ConfigurationOfAmbientTalkST methodsFor: 'versions' stamp: 'StefanMarr 1/13/2013 19:30'!
version03: spec
	<version: '0.3-phd2013' imports: #('0.3-baseline') >

	spec for: #'common' do: [
		spec blessing: #'phd2013'.
		spec description: 'Configuration reflecting the project status used for benchmarks in my PhD dissertation'.
		spec author: 'StefanMarr'.
		spec timestamp: '1/13/2013 15:11'.
	
		spec
			package: 'AmbientTalkST-Core'       with: 'AmbientTalkST-Core-StefanMarr.14';
			package: 'AmbientTalkST-Benchmarks' with: 'AmbientTalkST-Benchmarks-StefanMarr.27';
			package: 'CLBG-Compatibility'       with: 'CLBG-Compatibility-StefanMarr.1'
	].! !
